slackbuilds_ponce/academic/rpy2/rpy2.SlackBuild
brobr 49c1200ba6
academic/rpy2: Update to version 3.5.15
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
2024-01-03 10:07:20 +07:00

123 lines
3.6 KiB
Bash

#!/bin/bash
#
# SlackBuild for rpy2
#
# Copyright 2020-2024 Rob van Nues (sborg63@disroot.org)
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
cd $(dirname $0) ; CWD=$(pwd)
PRGNAM=rpy2
VERSION=${VERSION:-3.5.15}
BUILD=${BUILD:-1}
TAG=${TAG:-_SBo}
PKGTYPE=${PKGTYPE:-tgz}
if [ -z "$ARCH" ]; then
case "$( uname -m )" in
i?86) ARCH=i586 ;;
arm*) ARCH=arm ;;
*) ARCH=$( uname -m ) ;;
esac
fi
if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
exit 0
fi
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
if [ "$ARCH" = "i586" ]; then
SLKCFLAGS="-O2 -march=i586 -mtune=i686"
LIBDIRSUFFIX=""
elif [ "$ARCH" = "i686" ]; then
SLKCFLAGS="-O2 -march=i686 -mtune=i686"
LIBDIRSUFFIX=""
elif [ "$ARCH" = "x86_64" ]; then
SLKCFLAGS="-O2 -fPIC"
LIBDIRSUFFIX="64"
else
SLKCFLAGS="-O2"
LIBDIRSUFFIX=""
fi
set -e
rm -rf $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
rm -rf $PRGNAM-$VERSION
tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
cd $PRGNAM-$VERSION
chown -R root:root .
find -L . \
\( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
-o -perm 511 \) -exec chmod 755 {} \; -o \
\( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
-o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
## make sure there is R
if ! [ -x "$(command -v R)" ]; then
echo 'Error: R is not installed.' >&2
exit 1
fi
## make sure that R has been compiled with
## --enable-R-shlib
## --enable-BLAS-shlib
RHOMLIB=$(R RHOME)
echo Found R libs:
echo $RHOMLIB/lib/*
if ! [ "$(readelf -h $RHOMLIB/lib/libR*.so | grep DYN)" ]; then
echo "Error: R is not compiled with shared libraries." >&2
exit 1
fi
## this removes an error message from setup.py
## https://github.com/rpy2/rpy2/issues/675
export LD_LIBRARY_PATH="${RHOMLIB}/lib:${LD_LIBRARY_PATH}"
echo "LD_LIBRARY_PATH set to ${LD_LIBRARY_PATH}"
# replace deprecated `python3 setup.py build install --root=$PKG`
# thanks to fourtysixandtwo
export PYTHONPATH=/opt/python3.9/site-packages/
python3 -m build --no-isolation
python3 -m installer -d "$PKG" dist/*.whl
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a AUTHORS gpl-2.0.txt NEWS README* $PKG/usr/doc/$PRGNAM-$VERSION
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
## to facilitate dynamic linking with R,
## libR.so and libRblas.so still need to be found
## https://github.com/rpy2/rpy2/issues/675
mkdir -p $PKG/etc/ld.so.conf.d/
cat $CWD/Rlibs.conf > $PKG/etc/ld.so.conf.d/Rlibs.conf
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh
cd $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE